#include <stdlib.h>
#include <avr/io.h>
#include <avr/delay.h>
#include "compatible.h"
#include "usart.c"


void sendACK(void)
	{
	usart_putc('O');
	}
void sendNACK(void)
	{
	usart_putc('T');
	}

void testbeep(void)	//testowa
	{
	sbi(PORTD,5);
	_delay_loop_2(0xFFFF);				
	cbi(PORTD,5);		
	}


//ustawienie portu danych pamieci
void set_data(uint8_t data)
	{
	PORTA=data;
	}
	
	
//ustawienie adresu	
void set_adr(uint32_t adros)
	{
	PORTB=(uint8_t)(adros&0x000000FF);
	PORTC=(uint8_t)((adros>>8)&0x000000FF);
	//MSB-1
	if(adros&0x00010000) sbi(PORTD,2);
		else cbi(PORTD,2);
	//MSB
	if(adros&0x00020000) sbi(PORTD,3);
		else cbi(PORTD,3);
	}

void send_command(uint8_t data, uint32_t adr)
	{
	set_adr(adr);
	set_data(data);
	cbi(PORTD,4);	//#WE=0
	cbi(PORTD,6);	//#CE
	sbi(PORTD,7);	//#OE zawsze H
	_delay_loop_2(0x0006);
	
	sbi(PORTD,4);	//#WE=1
	//sbi(PORTD,6);	//#CE
	//sbi(PORTD,7);
	_delay_loop_2(0x0003);
	}

void command(uint8_t data, uint32_t adr)
	{
	set_adr(adr);
	set_data(data);
	cbi(PORTD,4);	//#WE=0
	cbi(PORTD,6);	//#CE
	sbi(PORTD,7);	//#OE zawsze H
	_delay_loop_2(0x0001);
	
	sbi(PORTD,4);
	//sbi(PORTD,6);	//#CE
	//sbi(PORTD,7);
	_delay_loop_2(0x0001);
	}

//shit, bedzie to wymagalo dodatkowej linii
//do sterowania #CE	
uint8_t read_flash(uint32_t adr)
	{
	uint8_t temp;
	set_adr(adr);
	sbi(PORTD,4);	//#WE=H
	cbi(PORTD,6);	//#CE - uaktywnienie
	cbi(PORTD,7);	//#OE=L
	//_delay_loop_2(0x0010);
	asm volatile ("nop");
	asm volatile ("nop");
	temp=PINA;
	
	//sbi(PORTD,6);	//chip disable
	//sbi(PORTD,7);	//#OE=H
	//_delay_loop_2(0x0005);
	asm volatile ("nop");
	asm volatile ("nop");
	return temp;
	}
	
//odbior bajtu z potwierdzeniem z RSa;
//funkcja zwraca sterowanie dopiero gdy uzyska wazna dana
uint8_t receive_byte(void)
	{
	uint8_t temp,prevRSbyte,stan=0;
	uint8_t accepted=0;
	while(accepted==0)	//dopoki nie zaakceptowano danej
		{
		if(stan==0) 
			{
			while(usart_unread_data()==0){};	//wait for data
			prevRSbyte=usart_getc();
			stan=1;
			}
		if(stan==1)
			{
			while(usart_unread_data()==0){};	//wait for data
			temp=usart_getc();
			stan=0;
			}
			
		if(temp==prevRSbyte)
			{
			accepted=1;
			sendACK();
			}
		else
			{
			accepted=0;	
			sendNACK();
			}
		}
	return temp;	//zwroc zaakcetowany bajt
	}


void WriteByte(uint8_t temp)
	{
	char reply;
	do
		{
		usart_putc(temp);
		usart_putc(temp);
		reply = usart_getc();
		if(reply=='T') testbeep();
		}
	while(reply!='O');	//data accepted
	}


int main(void)
{
uint8_t temp,temp2;
char code_letter=0;

uint8_t unlocked_erase=0,read=0,erase=0;

uint8_t data;
uint32_t adresik=0;

DDRA=0xFF;
DDRB=0xFF;
DDRC=0xFF;
DDRD=0xFF;

testbeep();
_delay_loop_2(0xFFFF);	//rozbiegoowa


//19200, 8N1
//z kwarcem 4MHz sa klopoty dla wyzszych baudrate
usart_init(USART_BAUDRATE(19200, 4));	//sprytne define makro z usart.h, br = baudrate, fosc = clock frequency in megahertzs

//PORTA: data
//PORTB,PORTC,PD2,PD3 : adres od LSB
//PD4: #WE
//PD5: led
//PD6: #CE
//PD7: #OE

//kazdy bajt podwojony i wymagane ACK/NACK
//ACK: O, NACK: T






while(1){
	
	cbi(PORTD,6);
	
	
	//oczekiwanie na sekwencje odblokowujaca ABC
	while(unlocked_erase==0&&read==0&&erase==0)
		{
		if(usart_unread_data()>0) temp=usart_getc();
		if(temp=='A') code_letter='A';
		else if(code_letter=='A' && temp=='B') code_letter='B';
		else if(code_letter=='B' && temp=='C') 
			{
			code_letter='C';
			unlocked_erase=1;
			}
		if(temp!='A'&&temp!='B'&&temp!='C'&&temp!='R'&&temp!='E') code_letter=0;	//resecik
		//read
		if(temp=='R') read=1;
		if(temp=='E') erase=1;
		//czy wysylac ack teraz czy po kasowaniu?
		}
	sendACK();
		
	if(unlocked_erase==1)
		{
		//dla pewnosci
		DDRA=0xFF;
		
		testbeep();
		testbeep();
		testbeep();
		
		sbi(PORTD,7);
		
		//sekwencja kasowania pamieci
		/*
		send_command(0xAA,0x00005555);
		send_command(0x55,0x00002AAA);
		send_command(0x80,0x00005555);
		send_command(0xAA,0x00005555);
		send_command(0x55,0x00002AAA);
		send_command(0x10,0x00005555);
		*/
		command(0xAA,0x00005555);
		command(0x55,0x00002AAA);
		command(0x80,0x00005555);
		command(0xAA,0x00005555);
		command(0x55,0x00002AAA);
		command(0x10,0x00005555);
		
		//DDRA=0x00;	//zebym moglo sprawdzic bit 7
		
		for(temp=0;temp<25;temp++) _delay_loop_2(0xFFFF);	//oczekiwanie na skasowanie zawartosci
		sendACK();
		
		//DDRA=0xFF;
		//koniec sekwencji kasowania pamieci
	
		//zapis
		adresik=0;
		//cbi(PORTD,6);	//ustaw #CE
		for(adresik=0;adresik<262144;adresik++)
			{
			
			data=receive_byte();
			//sekwencja programowania bajtu
			send_command(0xAA,0x00005555);
			send_command(0x55,0x00002AAA);
			send_command(0xA0,0x00005555);
			//send_command(data,adres);
			send_command(data,adresik);
			_delay_loop_2(0x0020);
			
			//koniec sekwencji programowania bajtu
			
			//adresik++;
			}
		//sbi(PORTD,6);	//chip disable	
		
		//no to infinite loop
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		}
	
	//odczyt
	if(read==1)
		{
		testbeep();
		adresik=0;
		//cbi(PORTD,6);	//ustaw #CE - nie, bo odczyt go ustawia
		
		//sbi(PORTD,6);	//wylacz chip
		
		//cbi(PORTD,7);	//#OE = 0
		DDRA=0x00;	//wejscie
		for(adresik=0;adresik<262144;adresik++)
			{
			temp=read_flash(adresik);
			WriteByte(temp);
			}
		DDRA=0xFF;	//wyjscie
		//cbi(PORTD,6);	
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		}
	if(erase==1)
		{
		do
			{
			//dla pewnosci
			DDRA=0xFF;
			PORTA=0x00;
			testbeep();
			testbeep();
			
			sbi(PORTD,7);
			
			//sekwencja kasowania pamieci
			/*
			send_command(0xAA,0x00005555);
			send_command(0x55,0x00002AAA);
			send_command(0x80,0x00005555);
			send_command(0xAA,0x00005555);
			send_command(0x55,0x00002AAA);
			send_command(0x10,0x00005555);
			*/
			/*
			command(0xAA,0x00005555);
			command(0x55,0x00002AAA);
			command(0x80,0x00005555);
			command(0xAA,0x00005555);
			command(0x55,0x00002AAA);
			command(0x10,0x00005555);
			*/
			
			/*
			set_adr(0x00005555);
			set_data(0x55);
			cbi(PORTD,4);	//#WE=0
			cbi(PORTD,6);	//#CE
			sbi(PORTD,7);	//#OE zawsze H
			asm volatile ("nop"); 
			sbi(PORTD,4);
			asm volatile ("nop"); 
			
			set_adr(0x00002AAA);
			set_data(0x55);
			cbi(PORTD,4);	//#WE=0
			cbi(PORTD,6);	//#CE
			sbi(PORTD,7);	//#OE zawsze H
			asm volatile ("nop"); 
			sbi(PORTD,4);
			asm volatile ("nop"); 
			
			set_adr(0x00005555);
			set_data(0x80);
			cbi(PORTD,4);	//#WE=0
			cbi(PORTD,6);	//#CE
			sbi(PORTD,7);	//#OE zawsze H
			asm volatile ("nop"); 
			sbi(PORTD,4);
			asm volatile ("nop"); 
			//4
			set_adr(0x00005555);
			set_data(0xAA);
			cbi(PORTD,4);	//#WE=0
			cbi(PORTD,6);	//#CE
			sbi(PORTD,7);	//#OE zawsze H
			asm volatile ("nop"); 
			sbi(PORTD,4);
			asm volatile ("nop"); 
			//5
			set_adr(0x00002AAA);
			set_data(0x55);
			cbi(PORTD,4);	//#WE=0
			cbi(PORTD,6);	//#CE
			sbi(PORTD,7);	//#OE zawsze H
			asm volatile ("nop"); 
			sbi(PORTD,4);
			asm volatile ("nop"); 
			//6
			set_adr(0x00005555);
			set_data(0x10);
			cbi(PORTD,4);	//#WE=0
			cbi(PORTD,6);	//#CE
			sbi(PORTD,7);	//#OE zawsze H
			asm volatile ("nop"); 
			sbi(PORTD,4);
			asm volatile ("nop"); 
			*/
					
			
			command(0xAA,0x00005555);
			command(0x55,0x00002AAA);
			command(0x80,0x00005555);
			command(0xAA,0x00005555);
			command(0x55,0x00002AAA);
			command(0x10,0x00005555);
			
			DDRA=0x00;	//zebym moglo sprawdzic bit 7
			cbi(PORTD,7);	//#OE
			PORTA=0xFF;	//podciagniecie
			temp2=PINA&0x80;	//odmaskowanie bitu 7
			for(temp=0;temp<25;temp++) _delay_loop_2(0xFFFF);	//oczekiwanie na skasowanie zawartosci
			}
		while(temp2!=0);
		
		//sendACK();
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		testbeep();
		_delay_loop_2(0xFFFF);
		}
		
	unlocked_erase=0;	//zablokowanie zapisu
	read=0;				//koniec odczytu
	erase=0;
	};	
return 0;
}	
